using UnityEngine;
using System.Collections;
using System.Collections.Generic;


public class Character : MonoBehaviour {
    //
    
    //    
    SpriteManager spriteManager;
    Sprite sprite;
    //
    public int spriteIdle = 0;
    public int spriteIdleRow = 0;
    public int spriteIdleFrames = 3;
    public int spriteWalk = 5;
    public int spriteWalkRow = 0;
    public int spriteWalkFrames = 6;
    public int spriteJump = 4;
    public int spriteJumpRow = 0;
    public int spriteJumpFrames = 1;
    public int spriteDie = 11;
    public int spriteDieRow = 0;
    public int spriteDieFrames = 6;
    public int spriteDieLaser = 11;
    public int spriteDieLaserRow = 0;
    public int spriteDieLaserFrames = 6;
    public int spriteDieFire = 11;
    public int spriteDieFireRow = 0;
    public int spriteDieFireFrames = 6;
    public int spriteAttack = 5;
    public int spriteAttackRow = 0;
    public int spriteAttackFrames = 2;
    public int spriteUse = 15;
    public int spriteUseRow = 0;
    public int spriteUseFrames = 2;
    public int spriteLaptop = 5;
    //
    public int spritePixels = 24;
    public int spriteSize = 24;
    //
    public bool robotLaser = false;
    //
    int frame = 0;
    public float frameRate = 0.066f;
    float counter = 0;
    //
    public ActionType action = ActionType.Idle;
    
    Vector3 targetPosition;
    public Vector3 pos = Vector3.zero;
    public float speed = 10;
    public Vector3 velocity = Vector3.zero;
    static public float ground = -21;
   
   
    Transform thisTransform;
    // 
    Rigidbody body;
    //
    public bool evil = false;
    public bool dead = false;
    public float dieTime = 1.5f;
    public bool canExplode = true;
    //
    bool playerControlled = false;
    public bool touchingGround = false;
    LayerMask groundLayer, playerLayer;
    //
   
    public ExplosionType explosionType = ExplosionType.GoodShip;
  
    //
    void Awake() { // ** Awake executed before Start **
        body = rigidbody;
        groundLayer = 1 << 9;
        playerLayer = 1 << 10;
    }
	void Start () { 
        // ** Start occurs once just before the first frame the gameobject is active
        Map.AddCharacter(this); // ** Adds this ships to the map list<> **
        //
        if (!dead) {
            //
            thisTransform = transform;
            if (spriteManager == null) { // ** this only happens if the ship is already on the stage and has not been intantiated by the Map class
                GameObject uD = GameObject.Find("SpriteManagerEntities");
                spriteManager = uD.GetComponent(typeof(SpriteManager)) as SpriteManager;
                sprite = spriteManager.AddSprite(gameObject, spritePixels, spritePixels, spriteIdle * spritePixels, (spriteIdleRow + 1) * spritePixels, spritePixels, spritePixels, false);


            }
            targetPosition = thisTransform.position;

            dead = false;
            counter = Random.value * frameRate;
            sprite.SetSizeXZ(spriteSize, spriteSize);
            //transform.eulerAngles = new Vector3(180, 0, Mathf.Round(rotation / 90) * 90);
            transform.eulerAngles = new Vector3(-90, 0, 0);

            //pos = new Vector3(transform.position.x, ground, 0);
            //transform.position = pos;
        } else {
            gameObject.active = false;
        }

	}   

    /*
    void FindRandomEnemyShip() {
        Transform targetAlliedShip = Map.GetRandomShip(!evil);
        if (targetAlliedShip != null) {
            SetDestination(targetAlliedShip);
        }
    }
     */
	void Update () {
       
        float t = Time.deltaTime;
        counter += t;
        RaycastHit hit;
        Ray ray = new Ray(transform.position, Vector3.down);
        if (Physics.Raycast(new Ray(transform.position + Vector3.right * 3.6f, Vector3.down), out hit, 9, groundLayer) ) {
            if (body.velocity.y <= 0) {
                transform.position = hit.point + Vector3.up * 8 - Vector3.right * 3.6f;
                
            }
            touchingGround = true;
          //  Debug.Log("Touching Ground ");
        } else if (Physics.Raycast(new Ray(transform.position - Vector3.right * 3.6f, Vector3.down), out hit, 9, groundLayer)) {
            //Debug.Log("Hit " + hit.point);
            if (body.velocity.y <= 0) {
                transform.position = hit.point + Vector3.up * 8 + Vector3.right * 3.6f;
                
            }
            touchingGround = true;
        }else {
            //Debug.Log("Hit " + hit.point);
           
            touchingGround = false;
        }
        if (counter >= frameRate) {
            // ** the next frame of the animation, in the case of ships this is just the sparkles moving around
            counter -= frameRate;
            frame++;
            // ** Animate controls the sprite's frame
            Animate();
            //
           
        }
        if (!dead) {
         
            if (action == ActionType.Idle) {
                body.velocity *= (1 - t*7 );
                //pos += velocity * t;
                if (touchingGround && Mathf.Abs(body.velocity.x) < 2) {
                    pos = transform.position;
                    transform.position = new Vector3(Mathf.Round(pos.x), Mathf.Round(pos.y), 0);
                } else if (!touchingGround) {
                    action = ActionType.Jump;
                }
            } else if (action == ActionType.Walk) {

                pos = transform.position;
                if (!evil) {
                    if (pos.x > 80 && body.velocity.x > 0) {
                        if (!Map.NextLevel()) {

                            body.velocity = new Vector3(0, body.velocity.y, 0);
                        }
                    } else if (pos.x < -80 && body.velocity.x < 0) {
                        if (!Map.PreviousLevel()) {
                            body.velocity = new Vector3(0, body.velocity.y, 0);
                        }
                    }
                }
                if (!touchingGround) {
                    action = ActionType.Jump;
                }
                pos = transform.position;
                transform.position = new Vector3(pos.x, pos.y, 0);
                //pos += velocity * t;
                //transform.position = new Vector3(pos.x, pos.y, 0);
            } else if (action == ActionType.Die || action == ActionType.DieLaser || action == ActionType.DieFire) {
                body.velocity *= (1 - t * 1);
              
                pos = transform.position;
                //transform.position = new Vector3(Mathf.Round(pos.x), Mathf.Round(pos.y), 0);
            } else if (action == ActionType.Jump) {
                if (!evil) {
                    if (pos.x > 80 && body.velocity.x > 0) {
                        if (!Map.NextLevel()) {

                            body.velocity = new Vector3(0, body.velocity.y, 0);
                        }
                    } else if (pos.x < -80 && body.velocity.x < 0) {
                        if (!Map.PreviousLevel()) {
                            body.velocity = new Vector3(0, body.velocity.y, 0);
                        }
                    }
                }
                // Debug.Log("Jumping ");
                if (touchingGround && body.velocity.y < 1) {
                    action = ActionType.Idle;
                }
                if (!playerControlled) {
                    body.velocity = new Vector3(body.velocity.x * (1 - t * 11), body.velocity.y, 0);
                }
                pos = transform.position;
                transform.position = new Vector3(pos.x, pos.y, 0);
                //pos = transform.position;
                //transform.position = new Vector3(Mathf.Round(pos.x), Mathf.Round(pos.y), 0);
            }
           
            
            sprite.Transform(); // ** the sprite must be transformed every frame because the RigidBody is affecting it's position
        } else {
            // *** dead and floating for a bit ** 

            if (sprite != null) {
                sprite.Transform();
            }
            if (canExplode) {
                
                dieTime -= t;
                if (dieTime <= 0) {
                    Explode(); // ** Explode is the ship's final death, it destroys the gameObject and everything attached
                }
               
            }
            
        }
        playerControlled = false;
        
	}
    public void Setup(SpriteManager spriteManager, SpriteManager spriteManagerBlips) {
        // ** this is called when instantiating the ship, possibly unecessary, but it saves every new ship seraching through all the gameobjects to find the spritemanagers
        this.spriteManager = spriteManager;
        sprite = spriteManager.AddSprite(gameObject, spritePixels, spritePixels, spriteIdle * spritePixels, (spriteIdleRow + 1) * spritePixels, spritePixels, spritePixels, false);       
       
    }
   
   
    
    public SpriteManager GetSpriteManager() {
        return spriteManager; // ** Called by attached Guns
    }
    public void GotoLaptop() {
        if (touchingGround && !dead) {
            sprite.lowerLeftUV = spriteManager.PixelCoordToUVCoord((spriteLaptop) * spritePixels, (spriteIdleRow + 1) * spritePixels);
        }
    }
    public void Animate() {

        if (action == ActionType.Idle) {
            int frameOffset = spriteIdle + frame % spriteIdleFrames;
            sprite.lowerLeftUV = spriteManager.PixelCoordToUVCoord((frameOffset) * spritePixels, (spriteIdleRow + 1) * spritePixels);
        } else if (action == ActionType.Walk) {
            int frameOffset = spriteWalk + frame % spriteWalkFrames;
            sprite.lowerLeftUV = spriteManager.PixelCoordToUVCoord((frameOffset) * spritePixels, (spriteWalkRow + 1) * spritePixels);
        } else if (action == ActionType.Die) {
            int frameOffset = spriteDie;
            sprite.lowerLeftUV = spriteManager.PixelCoordToUVCoord((frameOffset) * spritePixels, (spriteDieRow + 1) * spritePixels);
        } else if (action == ActionType.DieLaser) {
            int frameOffset = spriteDieLaser + Mathf.Clamp(frame, 0, spriteDieLaserFrames);
            sprite.lowerLeftUV = spriteManager.PixelCoordToUVCoord((frameOffset) * spritePixels, (spriteDieRow + 1) * spritePixels);
        } else if (action == ActionType.DieFire) {
            int frameOffset = spriteDieFire + Mathf.Clamp(frame, 0, spriteDieFireFrames);
            sprite.lowerLeftUV = spriteManager.PixelCoordToUVCoord((frameOffset) * spritePixels, (spriteDieRow + 1) * spritePixels);
        } else if (action == ActionType.Jump) {
            int frameOffset = spriteJump + frame % spriteJumpFrames;
            sprite.lowerLeftUV = spriteManager.PixelCoordToUVCoord((frameOffset) * spritePixels, (spriteJumpRow + 1) * spritePixels);
        } else if (action == ActionType.Attack) {
            int frameOffset = spriteAttack + frame % spriteAttackFrames;
            sprite.lowerLeftUV = spriteManager.PixelCoordToUVCoord((frameOffset) * spritePixels, (spriteAttackRow + 1) * spritePixels);
            if (frame == 1) {
                if (Shoot()) {
                    Sound.PlaySound(SoundType.Shoot, 0.6f);
                    gameObject.SendMessage("CoolDown");
                }
            }
            if (frame == 6 && robotLaser) {
                Rest();
            }
        }
    }
    public void SetDestination(Vector3 pos) {
        // ** Sets a new course for a position **
        targetPosition = pos;
       
    }
    public void Walk(Vector3 direction) {
        if (!dead) {
            if (action != ActionType.Jump) {
                Vector3 d = direction.normalized;
                RaycastHit hit;
                Ray ray = new Ray(transform.position, direction.normalized);
                if (!Physics.Raycast(new Ray(transform.position + Vector3.down * 7, d), out hit, 6, groundLayer)) {

                    if (action != ActionType.Walk) {
                        frame = 0;
                        Animate();
                    }
                    if (direction.x > 0) {
                        sprite.SetSizeXZ(spriteSize, spriteSize);
                    } else {
                        sprite.SetSizeXZ(-spriteSize, spriteSize);
                    }
                    action = ActionType.Walk;
                    body.AddForce(new Vector3(direction.x - body.velocity.x, 0, 0) * Time.deltaTime * 1000);
                    playerControlled = true;
                } else {
                    if (!Physics.Raycast(new Ray(transform.position + Vector3.down * 3, d), out hit, 6, groundLayer)) {

                        body.AddForce(new Vector3((direction.x - body.velocity.x) / 10, 5, 0) * Time.deltaTime * 1000);
                        playerControlled = true;
                        action = ActionType.Walk;
                    }
                }
                //body.velocity = new Vector3(direction.x, body.velocity.y, 0);
            } else {
                Vector3 d = direction.normalized;
                RaycastHit hit;
                Ray ray = new Ray(transform.position, direction.normalized);
                if (!Physics.Raycast(new Ray(transform.position + Vector3.down * 7, d), out hit, 6, groundLayer)) {

                    if (direction.x > 0) {
                        sprite.SetSizeXZ(spriteSize, spriteSize);
                    } else {
                        sprite.SetSizeXZ(-spriteSize, spriteSize);
                    }

                    body.AddForce(new Vector3(direction.x - body.velocity.x, 0, 0) * Time.deltaTime * 1000);
                } else {
                    if (!Physics.Raycast(new Ray(transform.position + Vector3.down * 3, d), out hit, 6, groundLayer)) {

                        body.AddForce(new Vector3((direction.x - body.velocity.x) / 10, 4, 0) * Time.deltaTime * 1000);
                    }
                }
                //  body.velocity = new Vector3(direction.x, body.velocity.y, 0);
                playerControlled = true;
            }
        }
    }
    public void Stop() {
        if (action != ActionType.Jump && action != ActionType.Attack && !dead) {
            action = ActionType.Idle;
        }
    }
    public void Rest() {
        if (!dead) {
            action = ActionType.Idle;
        }
        
    }
    public void Attack(Vector3 point) {
        if (!dead) {
            targetPosition = point;
            frame = 0;
            counter = 0;
            Animate();
            action = ActionType.Attack;
            if (point.x > transform.position.x) {
                sprite.SetSizeXZ(spriteSize, spriteSize);
            } else {
                sprite.SetSizeXZ(-spriteSize, spriteSize);
            }
            gameObject.SendMessage("CoolDown");

        }
    }
    bool Shoot() {
       
        RaycastHit hitCharacter, hitGround;
        float xDiff = Mathf.Abs(targetPosition.x - transform.position.x );
        Vector3 direction = Vector3.right * Mathf.Sign(targetPosition.x - transform.position.x);
        Ray ray = new Ray(transform.position + Vector3.up * 1f, direction);
        //Debug.Log("Shooting " + xDiff);
        float characterXdiff = 1000;
        float groundXdiff = 1000;
        if (Physics.Raycast(ray, out hitGround, 80, groundLayer)) {
            //Debug.Log("HitGround");
            groundXdiff = Mathf.Abs(hitGround.collider.transform.position.x - transform.position.x);
            
        } 
        
        if (Physics.Raycast(ray, out hitCharacter, 80, playerLayer)) {
            //Debug.Log("Hit Player");
            characterXdiff = Mathf.Abs(hitCharacter.collider.transform.position.x - transform.position.x);
            /*
            Collider other = hit.collider;
            Character otherCharacter = other.GetComponent(typeof(Character)) as Character;
            if (otherCharacter != null) {
                Debug.Log("Damage Player " + otherCharacter.gameObject.name);
                otherCharacter.Damage(direction);
            }
            Map.DrawBeam(transform.position + Vector3.up * 1f + direction, hit.point + direction * 2);
             */
        }
        if ((characterXdiff < 150 || groundXdiff < 150)) {
            if (characterXdiff < groundXdiff) {
                Collider other = hitCharacter.collider;
                Character otherCharacter = other.GetComponent(typeof(Character)) as Character;
                if (otherCharacter != null) {
                    //Debug.Log("Damage Player " + otherCharacter.gameObject.name);
                    otherCharacter.DamageLaser(direction);
                }
                Map.DrawBeam(transform.position + Vector3.up * 1f + direction, hitCharacter.point + direction * 2);
            } else {
                Collider other = hitGround.collider;
                Prop prop = other.GetComponent(typeof(Prop)) as Prop;
                if (prop != null) {
                    prop.Knock(ray.direction * 60);
                }
                Map.DrawBeam(transform.position + Vector3.up * 1f + direction, hitGround.point + direction * 2);
            }
        } else {
            Debug.Log("Shooting " + xDiff + " target " + targetPosition);
            Map.DrawBeam(transform.position + Vector3.up * 1f + direction, transform.position + Vector3.up + direction * 70);
        }
        /*
        else if (Physics.Raycast(ray, out hit, 60, groundLayer)) {
            //Debug.Log("HitGround");
            Collider other = hit.collider;
            Prop prop = other.GetComponent(typeof(Prop)) as Prop;
            if (prop != null) {
                prop.Knock(ray.direction * 60);
            }
            Map.DrawBeam(transform.position + Vector3.up * 1f + direction, hit.point + direction * 2);
        } else {
            Debug.Log("Shooting " + xDiff +  " target " +targetPosition);
            Map.DrawBeam(transform.position + Vector3.up * 1f + direction, transform.position + Vector3.up +direction * 70);
        }
           */

        //Map.DrawBeam(transform.position, targetPosition);
        return true;
    }
    public void Damage(Vector3 direction) {
        Sound.PlaySound(SoundType.No, 0.4f);
        body.velocity = direction;
        dead = true;
        action = ActionType.Die;
        frame = 0;
        counter = -0.2f;
        dieTime = 1.7f;
        Animate();
    }
    public void DamageFire(Vector3 direction) {
        Sound.PlaySound(SoundType.Missile, 0.4f);
        body.velocity = direction;
        dead = true;
        action = ActionType.DieFire;
        frame = 0;
        counter = -0.2f;
        Animate();
    }
    public void DamageLaser(Vector3 direction) {
        //Sound.PlaySound(SoundType.No, 0.4f);
        body.velocity = direction;
        dead = true;
        action = ActionType.DieLaser;
        frame = 0;
        counter = -0.2f;
        Animate();
    }
    public void Jump() {
        if (!dead) {
            if (touchingGround && body.velocity.y < 40) {
                Sound.PlaySound(SoundType.Laser, 0.6f);
                touchingGround = false;
                action = ActionType.Jump;
                if (body.velocity.y < 0) {
                    body.velocity = new Vector3(body.velocity.x, body.velocity.y * -0.4f + 50, 0);
                } else if (body.velocity.y > 0) {
                    body.velocity = new Vector3(body.velocity.x, body.velocity.y * 0.5f + 50, 0);
                } else {
                    body.velocity = Vector3.up * 50;
                }
                RaycastHit hit;
                Ray ray = new Ray(transform.position, Vector3.down);
                if (Physics.Raycast(ray, out hit, 15, groundLayer) ) {
                    hit.collider.SendMessage("Push", new Vector3(0,-50- body.velocity.y*0.2f, 0), SendMessageOptions.DontRequireReceiver);
                }
            }
        }
    }
    
    void Explode() { // *** Ship explodes / YAY **
        //spriteManager.RemoveSprite(sprite);
        //
        // ** This time I do use the Broadcast call because the guns get damaged and remove themselves from the list
        // ** otherwise I could have just itterated and called : guns[index].Disappear();        
        //
        //BroadcastMessage("Disappear", null, SendMessageOptions.DontRequireReceiver);
       //
       // Map.RemoveCharacter(this);
       // Map.Explosion(thisTransform.position, 100, explosionType);
        if (action == ActionType.Die || action == ActionType.DieLaser) {
            if (evil) {
                Map.Particles(transform.position, 90);
                //Map.Smoke(transform.position, 20);
                Map.SmokeBig(transform.position, 44);
                Map.Electric(transform.position, 17);
                Sound.PlaySound(SoundType.Explode, 0.6f);
            } else {
                Map.Blood(transform.position - Vector3.up * 2, 40);
                Map.BloodPixels(transform.position - Vector3.up * 2, 60);
                Sound.PlaySound(SoundType.Explode, 0.6f);
            }
        }
        Map.CharacterDeath(this);
        spriteManager.HideSprite(sprite);
        gameObject.active = false;
        canExplode = false;
        //sprite = null;
        // ** Destroying the gameObject destroys all children objects, like the guns
       // Destroy(gameObject);
        //
        //
    }
    public void Knock(Vector3 force) {

        action = ActionType.Fall;

        //body.angularVelocity = new Vector3(0, 0, (Random.value * 1 + 2) * Math.RandomNegativePositive());
        body.WakeUp();
        body.velocity += force;
    }
    void OnTriggerEnter(Collider other) {
        // ** All the colliders on the Projectiles are set to trigger
        // ** This means the friendly projectiles can pass over friendly ships without moving them around
        if (other.CompareTag("DeathAcid") && !dead) {
           
                DamageFire(Vector3.up * 40 + Vector3.right * body.velocity.x*0.5f);
          
        } else if (other.CompareTag("DeathFire") && !evil && !dead) {
           
            
                DamageFire(Vector3.up * 30 + (transform.position - other.transform.position).normalized * 20);
           
        } else if (other.CompareTag("DeathSpikes") && !dead) {            
           
                Damage(Vector3.up * 30 + (transform.position - other.transform.position).normalized * 20);

        } else if (other.CompareTag("DeathLaser") && !dead) {

            other.transform.parent.SendMessage("Shoot");

        } else if (other.CompareTag("Spikes") && !dead) {
            other.SendMessage("Switch", true);
              //  Damage(Vector3.up * 30 + (transform.position - other.transform.position).normalized * 20);

        } else if (other.CompareTag("Elevator") && !evil && !dead) {
            other.SendMessage("Switch", true);
           
        } else if (other.CompareTag("Turret") && !dead && !evil) {
            other.SendMessage("Switch", true);
            other.SendMessage("ActivateTurret", this);
            //  Damage(Vector3.up * 30 + (transform.position - other.transform.position).normalized * 20);

        } else if (other.CompareTag("ElevatorEnter") && !dead) {
            Player.canUseElevator = true;

        }    

    }
    void OnTriggerExit(Collider other) {
        // ** All the colliders on the Projectiles are set to trigger
        // ** This means the friendly projectiles can pass over friendly ships without moving them around
        if (other.CompareTag("Spikes") && !dead) {
            other.SendMessage("Switch", false);
            //  Damage(Vector3.up * 30 + (transform.position - other.transform.position).normalized * 20);

        } else if (other.CompareTag("ElevatorEnter")) {
            Player.canUseElevator = false;

        } else if (other.CompareTag("Turret") && !dead && !evil) {
            other.SendMessage("Switch", false);
            other.SendMessage("DeactivateTurret");

        } else if (other.CompareTag("Elevator") && !evil ) {
            other.SendMessage("Switch", false);

        } 


    }


}
