using UnityEngine;
using System.Collections;

public class Debri : MonoBehaviour {
    //
    SpriteManager spriteManager;
    Sprite sprite;
    //
    ParticleEmitter pEmitter;   
    float emitInterval = 0.04f;
    int emitCount = 2;
    //
    public int spriteStart = 0;
    public int spriteRow = 7;
    public int spriteFrames = 3;
    public float frameRate = 0.066f;
	//
    Vector3 velocity;    
    float a = 0;
    float angularVelocity = 90;
    //
   
    //
    bool isSetup = false;
    //
    float counter = 0;
    float life = 3;
    //
	
	
	void Update () {
        float t = Time.deltaTime;
        
        if (pEmitter != null) {
            counter += t;
            if (counter >= emitInterval) {
                counter -= emitInterval;
                Emit();
            }
        }
        a += angularVelocity * t; // ** turning in space **
        transform.eulerAngles = new Vector3(0, 0, a);
        transform.position += velocity * t;
        velocity *= 1 - t;
        sprite.Transform(); // ** the sprite must be transformed every frame because it is moving
        life -= t;
        if (life < 0) {
            spriteManager.RemoveSprite(sprite);
            Destroy(gameObject);
        }
	}
    void Emit() {
        pEmitter.transform.position = transform.position;
        pEmitter.Emit(emitCount);
    }
    public void Setup(SpriteManager spriteManager, ParticleEmitter pEmitter, float emitInterval, int emitCount, float life, Vector3 velocity) {
        if (!isSetup) {
            isSetup = true;
            this.pEmitter = pEmitter;
            this.emitInterval = emitInterval;
            this.emitCount = emitCount;
            this.life = life;
            this.velocity = velocity;           
            angularVelocity = Random.value * 360 - 180;
            a = Random.value * 360;
            //
            this.spriteManager = spriteManager;
            sprite = spriteManager.AddSprite(gameObject, 16, 16, spriteStart * 16, (spriteRow + 1) * 16, 16, 16, false);
        }
    }
}
