using UnityEngine;
using System.Collections;

public class Enemy : MonoBehaviour {
    //
    float counter = 0;
    float thinkTime = 1;
    float targetX = 0;
    float startX = 0;
    Character playerCharacter;
    Character character;
    bool atDestination = true;
    float shootCooldown = 2;
    float giveUpTime = 8;
    float giveUpCounter = 0;
    public float movementRadius = 30;
    public bool resetPosition = false;
    //
	void Awake () {
        character = gameObject.GetComponent(typeof(Character)) as Character;
        GameObject pC = GameObject.Find("PlayerCharacter");
        playerCharacter = pC.GetComponent(typeof(Character)) as Character;
        targetX = startX = transform.position.x; 

	}
	
	
	void Update () {
        if (!character.dead) {

            float t = Time.deltaTime;

            if (atDestination) {
                counter += t;

                if (counter > thinkTime) {
                    counter -= thinkTime;
                    targetX = startX + Random.value * movementRadius * Math.RandomNegativePositive();
                    atDestination = false;
                    giveUpCounter = 0;
                }
            } else {
                giveUpCounter += t;
                float dist = Mathf.Abs(targetX - transform.position.x);
                if (dist > 2) {
                    character.Walk(new Vector3(Mathf.Sign(targetX - transform.position.x) * 12, 0, 0));
                    if (giveUpCounter > giveUpTime) {
                        character.Stop();
                        atDestination = true;
                    } else if (dist < 10 && giveUpCounter > giveUpTime * 0.5f) {
                        character.Stop();
                        atDestination = true;
                    }
                } else {
                    character.Stop();
                    atDestination = true;
                }

            }
            if (shootCooldown > 0) {
                shootCooldown -= t;
            } else if (!playerCharacter.dead) {
                if (Mathf.Abs(playerCharacter.transform.position.x - transform.position.x) < 50) {
                    if (Mathf.Abs(playerCharacter.transform.position.y - transform.position.y) < 5) {
                        CoolDown();
                        character.Attack(playerCharacter.transform.position);
                    }
                }
            }
        }
	}
    public void Investigate(Vector3 position) {
        if (Mathf.Abs(transform.position.x - position.x) < 45 && Mathf.Abs(transform.position.y - position.y) < 10) {
            counter =0;
            giveUpCounter = 0;
            targetX = position.x;
            atDestination = false;
            giveUpCounter = 0;
        }
    }
    public void ResetPosition() {
        if (resetPosition) {
            startX = transform.position.x;
        }
    }
    public void CoolDown() {
        shootCooldown = 1f;
        counter = -1;
        atDestination = true;
    }
}
