using UnityEngine;
using System.Collections;

public class ExplosionWisp : MonoBehaviour {

    Vector3 velocity;
    float velocitySlowdown = 1f;
    ParticleEmitter pEmitter;
    //
    float emitInterval = 0.04f;
    int emitCount = 2;
    //
    float counter = 0;
    float life = 0.5f;
    //
    public void Setup(ParticleEmitter pEmitter, float emitInterval, int emitCount, float life, Vector3 velocity, float velocitySlowdown){
        this.life = life;
        this.pEmitter = pEmitter;
        this.emitCount = emitCount;
        this.emitInterval = emitInterval;
        this.velocity = velocity;
        this.velocitySlowdown = velocitySlowdown;
        counter = 0;        
    }
    void Emit() {
        pEmitter.transform.position = transform.position;
        pEmitter.Emit(emitCount);       
    }
    //
	void Update () {
        float t = Time.deltaTime;
        transform.position += velocity *t;
        velocity *= 1 - t * velocitySlowdown;
        counter += t;
        if (counter > emitInterval) {
            counter -= emitInterval;
            Emit();
        }
        
        life -= t;
        if (life <= 0) {
            
            Destroy(gameObject);            
        }
	}
}
