using UnityEngine;
using System.Collections;

public class Prop : MonoBehaviour {
    //
    SpriteManager spriteManager;
    Sprite sprite;

    //
    public int spriteIdle = 0;
    public int spriteIdleRow = 0;
    public int spriteIdleFrames = 3;
    
    public int spriteDie = 11;
    public int spriteDieRow = 0;
    public int spriteDieFrames = 6;
    //
    public int spritePixels = 24;
    public int spriteSize = 24;
    int frame = 0;
    public float frameRate = 0.066f;
    //
    public Vector3 pos = Vector3.zero;
    public float speed = 10;
   // public Vector3 velocity = Vector3.zero;
    static public float ground = -16f;
    public float zPos = 15;
    Rigidbody body;
    public bool dead = false;
    //
    public bool restingAtStart = true;
    bool floating = false;
    public bool pooFloat = false;
    //
    public float groundOffset = 0;
    //
    public ExplosionType explosionType = ExplosionType.EvilShip;
    //
    ActionType action = ActionType.Fall;
    //
	void Start () {
        GameObject uD = GameObject.Find("SpriteManagerProps");
        spriteManager = uD.GetComponent(typeof(SpriteManager)) as SpriteManager;
        sprite = spriteManager.AddSprite(gameObject, spritePixels, spritePixels, spriteIdle * spritePixels, (spriteIdleRow + 1) * spritePixels, spritePixels, spritePixels, false);
        transform.eulerAngles = Vector3.zero;
        sprite.SetSizeXY(spriteSize, spriteSize);
        Map.AddProp(this);
        pos = new Vector3(transform.position.x, transform.position.y, zPos);
        transform.position = pos;
        body = rigidbody;
        if (restingAtStart) {
            body.Sleep();
        } else {
            action = ActionType.Fall;
        }
       // Knock(Vector3.up);
	}
	
	// Update is called once per frame
	void Update () {
        float t = Time.deltaTime;
        if (action == ActionType.Fall) {
            body.velocity *= 1 - t;
            pos = transform.position;
            transform.position = new Vector3(pos.x, pos.y, zPos);
            transform.eulerAngles = new Vector3(0, 0, transform.eulerAngles.z);
            
        } else if (action == ActionType.Slide) {
           // body.velocity *= 1 - t * 7;
            transform.position = new Vector3(Mathf.Round(pos.x), Mathf.Round(pos.y), zPos);
            transform.eulerAngles = new Vector3(0, 0, transform.eulerAngles.z);
            /*
            if (Mathf.Abs(velocity.x) < 5) {
                velocity = Vector3.zero;
                action = ActionType.Idle;
                pos = transform.position;
            }
             */
        } else if (action == ActionType.Float) {
          
            body.velocity *= 1 - t ;
            transform.eulerAngles = new Vector3(0, 0, transform.eulerAngles.z);
            float angleTo = Mathf.Round(transform.eulerAngles.z / 90)*90;
            body.angularVelocity *= 1 - t*3;
            if (transform.position.y < -20) {
               
                float angleDiff = angleTo - transform.eulerAngles.z;
               // Debug.Log("AngleDiff " + angleDiff);
                body.angularVelocity += new Vector3(0, 0, angleDiff * t * 0.04f);
                if (!pooFloat) {
                    body.AddForce(new Vector3(0, -20 - transform.position.y, 0) * t * 2500);
                } else {
                    body.AddForce(new Vector3(0, -20 - transform.position.y, 0) * t * 700);
                }
            }
        }
        sprite.Transform();
	}
    void Animate() {

        if (action == ActionType.Idle) {
            int frameOffset = spriteIdle + frame % spriteIdleFrames;
            sprite.lowerLeftUV = spriteManager.PixelCoordToUVCoord((frameOffset) * spritePixels, (spriteIdleRow + 1) * spritePixels);
        } else if (action == ActionType.Die) {
            int frameOffset = spriteDie + frame % spriteDieFrames;
            sprite.lowerLeftUV = spriteManager.PixelCoordToUVCoord((frameOffset) * spritePixels, (spriteDieRow + 1) * spritePixels);
        }
    }
    public void Knock(Vector3 force) {
        Sound.PlaySound(SoundType.Hit, 0.6f);
        action = ActionType.Fall;

        body.angularVelocity = new Vector3(0, 0, (Random.value * 1 + 2) * Math.RandomNegativePositive());
        body.WakeUp();
        body.velocity += force;
    }
    public void Push(Vector3 force) {        

       // body.angularVelocity = new Vector3(0, 0, (Random.value * 1 + 2) * Math.RandomNegativePositive());
        body.WakeUp();
        body.AddForce(force*50);
    }
    void OnTriggerEnter(Collider other) {
        // ** All the colliders on the Projectiles are set to trigger
        // ** This means the friendly projectiles can pass over friendly ships without moving them around
        if (other.CompareTag("DeathAcid") && !dead) {

            action = ActionType.Float;

        }

    }
    void OnTriggerExit(Collider other) {
        // ** All the colliders on the Projectiles are set to trigger
        // ** This means the friendly projectiles can pass over friendly ships without moving them around
        if (other.CompareTag("DeathAcid") && !dead) {
            action = ActionType.Fall;

        } 


    }
}
