using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class MainMenu : MonoBehaviour {

    public static string nameText = "";
    // ** these are public so that I can edit them in the editor 
    public GUIStyle styleNameText;
    public GUIStyle styleNamePrompt;
    public GUIStyle styleScoreText;

    // ** these are public so that I can edit them in the editor 
    public GUIStyle styleScoreHilight;
    public GUIContent styleButtonContent;
    public GUIStyle styleButtonStyle;
    public Texture textureLogo;
    public GUIStyle styleLogo;
    bool mustEnterName = false;
    const int key = 2;
    //
    static List<string> names;
    static List<int> scores;
    static int lastScore = 0;
    //   
    bool nameIsKeyBoardFocussed = false;

    void Awake() {

        if (PlayerPrefs.GetInt("Key") == key) {
            // ** The Key constant can be changed to clear the scores, internal use only
            // ** Playerprefs works for both standalone and web releases, it stores a maximum of 1 Megabyte somewhere on your computer
            // ** It's pretty easy and very basic
            nameText = PlayerPrefs.GetString("LastName");
            scores = GetScores();
            names = GetNames();
        } else {
            nameText = "";
            names = new List<string>();
            scores = new List<int>();
            ClearScores();
        }
    }
    void Start() {
        Time.timeScale = 1;
        Sound.AdjustPitch();
        Sound.PlayMusic(MusicType.Menu);
    }
    void OnGUI() {
        // ** I decided to give the Unity Gui a try
        // ** It is pretty easy to work with, but at the cost of one drawcall for every element
        // ** So when I was done the main menu scene was bulked up to 71 drawcalls
        // ** Which is okay for a menu, I think, but irresponsible if used within the gamePlay
        //
        // ** have a look at the "styleNameText" variable in the editor, this is where the font and colour and background of the textField are set
        //
        //GUI.TextArea(new Rect(Screen.width / 2 - 400, Screen.height / 2 + 200, 230, 80), "NAME :", styleNameText);
        //       
        //
        // ** entering text is as simple as this. 
        //
      //  Rect nameRect = new Rect(Screen.width / 2 - 170, Screen.height / 2 + 200, 570, 80);
      //  nameText = GUI.TextArea(nameRect, nameText, 24, styleNameText);
        //
     //   GUI.SetNextControlName("BlankTextField");
     //   GUI.TextArea(new Rect(Screen.width / 2, Screen.height * 2, 20, 20), "nothing", 24, styleNameText);
        /*
        if (Input.GetButtonDown("Fire1")) {
            Vector2 correctedMousePosition = new Vector2(Input.mousePosition.x, (Screen.height - Input.mousePosition.y));
            if (!nameRect.Contains(correctedMousePosition)) {
                GUI.FocusControl("BlankTextField");
                nameIsKeyBoardFocussed = false;
            } else {
                nameIsKeyBoardFocussed = true;
            }

        }
         */
        //
        //
        /*
        if (mustEnterName) {
            GUI.TextArea(new Rect(Screen.width / 2 - 300, Screen.height / 2 + 270, 600, 80), "Please Enters Name", 24, styleNamePrompt);
        }
        if (scores.Count > 0) {
            // ** This bit writes out the scores **
            if (scores.Count > 8) {
                // ** writes scores in two collumns
                for (int i = 0; i < 8; i++) {
                    if (i < scores.Count) {
                        if (scores[i] == lastScore && nameText == names[i]) {
                            GUI.TextArea(new Rect(Screen.width / 2 - 278, Screen.height / 2 + 40 + i * 18, 200, 20), names[i], 24, styleScoreHilight);
                            GUI.TextArea(new Rect(Screen.width / 2 - 82, Screen.height / 2 + 40 + i * 18, 60, 20), "" + scores[i], 24, styleScoreHilight);
                        } else {
                            GUI.TextArea(new Rect(Screen.width / 2 - 278, Screen.height / 2 + 40 + i * 18, 200, 20), names[i], 24, styleScoreText);
                            GUI.TextArea(new Rect(Screen.width / 2 - 82, Screen.height / 2 + 40 + i * 18, 60, 20), "" + scores[i], 24, styleScoreText);
                        }
                    }
                }
                for (int i = 8; i < 16; i++) {
                    if (i < scores.Count) {
                        if (scores[i] == lastScore && nameText == names[i]) {
                            GUI.TextArea(new Rect(Screen.width / 2 + 22, Screen.height / 2 + 40 + (i - 8) * 18, 200, 20), names[i], 24, styleScoreHilight);
                            GUI.TextArea(new Rect(Screen.width / 2 + 218, Screen.height / 2 + 40 + (i - 8) * 18, 60, 20), "" + scores[i], 24, styleScoreHilight);
                        } else {
                            GUI.TextArea(new Rect(Screen.width / 2 + 22, Screen.height / 2 + 40 + (i - 8) * 18, 200, 20), names[i], 24, styleScoreText);
                            GUI.TextArea(new Rect(Screen.width / 2 + 218, Screen.height / 2 + 40 + (i - 8) * 18, 60, 20), "" + scores[i], 24, styleScoreText);
                        }
                    }
                }
            } else {
                // ** writes scores in one central collumn
                for (int i = 0; i < 8; i++) {
                    if (i < scores.Count) {
                        if (scores[i] == lastScore && nameText == names[i]) {
                            GUI.TextArea(new Rect(Screen.width / 2 - 138, Screen.height / 2 + 40 + i * 18, 200, 20), names[i], 24, styleScoreHilight);
                            GUI.TextArea(new Rect(Screen.width / 2 + 72, Screen.height / 2 + 40 + i * 18, 60, 20), "" + scores[i], 24, styleScoreHilight);
                        } else {
                            GUI.TextArea(new Rect(Screen.width / 2 - 138, Screen.height / 2 + 40 + i * 18, 200, 20), names[i], 24, styleScoreText);
                            GUI.TextArea(new Rect(Screen.width / 2 + 72, Screen.height / 2 + 40 + i * 18, 60, 20), "" + scores[i], 24, styleScoreText);
                        }
                    }
                }
            }
        }
         */
        /*
        // ** The enter button **
        if (GUI.Button(new Rect(Screen.width / 2 - 100, Screen.height / 2 - 100, 200, 200), styleButtonContent, styleButtonStyle)) {
            // ** Unity GUI buttons are awesome... you can just use  "if (GUI.Button( buttonDesign ){ " and it returns true whenever the button is pressed
            // ** have a look at the "styleButtonStyle" variable in the editor, this is where the image for the button and rollovers are set
            //
            if (nameText != "") {
                PlayerPrefs.SetString("LastName", nameText);
                PlayerPrefs.SetInt("Key", key);
                // ** Go to the gameplay level (the one refers to the index of the level in the publish settings 
                // ** this could also read: Application.LoadLevel("GamePlay"); but would still need to be in the publish settings
                Application.LoadLevel(1);
            } else {
                Sound.PlaySound(SoundType.No, 0.2f);
                mustEnterName = true;
            }
        }
         */
        // ** The Logo
        GUI.Box(new Rect(Screen.width / 2 - 512, Screen.height / 2 - 520, 1024, 1024), textureLogo, styleLogo);
        if (((int)Mathf.Round(Time.time * 2)) % 2 == 0) {
            GUI.TextArea(new Rect(Screen.width / 2 -200, Screen.height / 2 + 100, 400, 80), "PRESS TILDA", styleNameText);
        }
        //

    }
    void Update() {
        /*
        if (Input.GetKeyDown(KeyCode.A) || Input.GetKeyDown(KeyCode.B) || Input.GetKeyDown(KeyCode.C) || Input.GetKeyDown(KeyCode.D) || Input.GetKeyDown(KeyCode.E) || Input.GetKeyDown(KeyCode.F) || Input.GetKeyDown(KeyCode.G) || Input.GetKeyDown(KeyCode.H) || Input.GetKeyDown(KeyCode.I) || Input.GetKeyDown(KeyCode.J) || Input.GetKeyDown(KeyCode.K) || Input.GetKeyDown(KeyCode.L) || Input.GetKeyDown(KeyCode.M) || Input.GetKeyDown(KeyCode.N) || Input.GetKeyDown(KeyCode.O) || Input.GetKeyDown(KeyCode.P) || Input.GetKeyDown(KeyCode.Q) || Input.GetKeyDown(KeyCode.R) || Input.GetKeyDown(KeyCode.S) || Input.GetKeyDown(KeyCode.T) || Input.GetKeyDown(KeyCode.U) || Input.GetKeyDown(KeyCode.V) || Input.GetKeyDown(KeyCode.W) || Input.GetKeyDown(KeyCode.X) || Input.GetKeyDown(KeyCode.Y) || Input.GetKeyDown(KeyCode.Z) || Input.GetKeyDown(KeyCode.Alpha0) || Input.GetKeyDown(KeyCode.Alpha1) || Input.GetKeyDown(KeyCode.Alpha2) || Input.GetKeyDown(KeyCode.Alpha3) || Input.GetKeyDown(KeyCode.Alpha4) || Input.GetKeyDown(KeyCode.Alpha5) || Input.GetKeyDown(KeyCode.Alpha6) || Input.GetKeyDown(KeyCode.Alpha7) || Input.GetKeyDown(KeyCode.Alpha8) || Input.GetKeyDown(KeyCode.Alpha9)) {
            Sound.RandomPitch();
            Sound.PlaySound(SoundType.Beep, 0.1f);
        }
        if (!nameIsKeyBoardFocussed) {
            if (Input.GetKeyDown(KeyCode.M)) {
                if (Sound.IsOn()) {
                    Sound.SoundOff();
                } else {
                    Sound.SoundOn();

                }
            }
        }
         */
        if (Input.GetButtonDown("Fire2")) {
            Application.LoadLevel(1);
        }

    }
    static List<string> GetNames() {
        // ** gets the names out of the PlayerPrefs and stores them in the names list
        List<string> newNames = new List<string>();
        for (int i = 0; i < 16; i++) {
            if (PlayerPrefs.GetInt("Score" + i) > 0) {
                newNames.Add(PlayerPrefs.GetString("Name" + i));
            }
        }
        return newNames;
    }
    static List<int> GetScores() {
        // ** gets the scores out of the PlayerPrefs and stores them in the scores list
        List<int> newScores = new List<int>();
        for (int i = 0; i < 16; i++) {
            if (PlayerPrefs.GetInt("Score" + i) > 0) {
                newScores.Add(PlayerPrefs.GetInt("Score" + i));
            }
        }
        return newScores;
    }
    public static void InsertScore(string name, int score) {
        // ** this inserts a score before the next lowest score
        if (score > 0) {
            lastScore = score;
            bool insertedScore = false;
            if (scores.Count > 0) {
                for (int i = 0; i < scores.Count; i++) {
                    if (score > scores[i]) {
                        scores.Insert(i, score);
                        names.Insert(i, name);
                        insertedScore = true;
                        break;
                    }
                }
                if (!insertedScore && scores.Count < 16) {
                    scores.Add(score);
                    names.Add(name);
                }
            } else {
                scores.Add(score);
                names.Add(name);
            }
            // ** scores beyond the 16th get clipped
            SaveScores();
        }
    }
    static void SaveScores() {
        // ** sets the names and scores fields in the PlayerPrefs
        for (int i = 0; i < 16; i++) {
            if (scores.Count > i) {
                PlayerPrefs.SetInt(("Score" + i), scores[i]);
                PlayerPrefs.SetString(("Name" + i), names[i]);
            }
        }
    }
    static void ClearScores() {
        // ** Blanks out the names and scores fields in the PlayerPrefs
        for (int i = 0; i < 16; i++) {
            PlayerPrefs.SetInt(("Score" + i), 0);
            PlayerPrefs.SetString(("Name" + i), "");
        }
    }
}
