using UnityEngine;
using System.Collections;

public class Math {
    // ***********************************   I USE THIS TO DO A LITTLE 2D MATH AND USE A COUPLE LOOKUP TABLES  ***********
	static public float timer = 0;
    static float[] sinLookupTable;
    static float[] cosLookupTable;
    static int lookupResolution = 1000;
    static Vector3[] vectorLookupTable;
    static public float PI2 = 1;
    static public float invPI2 = 1;

    static public void SetupLookupTables() {
        PI2 = Mathf.PI * 2;
        invPI2 = 1 / PI2;
        sinLookupTable = new float[lookupResolution];
        for (int i = 0; i < lookupResolution; i++) {
            sinLookupTable[i] = Mathf.Sin(Mathf.PI * 2 / lookupResolution * i);
        }
        cosLookupTable = new float[lookupResolution];
        for (int i = 0; i < lookupResolution; i++) {
            cosLookupTable[i] = Mathf.Cos(Mathf.PI * 2 / lookupResolution * i);
        }
        vectorLookupTable = new Vector3[lookupResolution];
        for (int i = 0; i < lookupResolution; i++) {
            vectorLookupTable[i] = new Vector3(Cos(Mathf.PI * 2 / lookupResolution * i), Sin(Mathf.PI * 2 / lookupResolution * i), 0);
            
        }
    }
    static public float Sin(float a) {
        
        return sinLookupTable[(int)(Mathf.Repeat(a, PI2) * invPI2 * lookupResolution)];
    }
    static public float Cos(float a) {
        return cosLookupTable[(int)(Mathf.Repeat(a, PI2) * invPI2 * lookupResolution)];
    }
    static public Vector3 RandomPointOnCircle() {
		return Point3OnCircle(Random.value * PI2 , 1f);			
	}
    static public Vector3 Point3OnCircle(float angle, float radius) {
      
        return vectorLookupTable[(int)(Mathf.Repeat(angle, PI2) * invPI2 * lookupResolution)]*radius;
      
    }
	static public Vector2 Point2OnCircle(float angle, float radius) {		
		Vector2 u = Vector2.zero;		
		float c  = Cos(angle);
		float s = Sin(angle);
		u.x =(s * radius);
		u.y =(c * radius);
		return u;
	}
	static public Vector3 ForceZeroZ( Vector3 v) {
		return new Vector3(v.x , v.y, 0);
	}
	static public int RandomNegativePositive() {
		if (Random.value > 0.5f) {
			return -1;
		} else {
			return 1;
		}
	}
	
	static public float GetAngle(Vector2 v) {		
		return Mathf.Atan2(v.y , v.x) ;		
	}
    static public float GetAngle(Vector3 v) {
        return Mathf.Atan2(v.y, v.x);
    }
	

}
